/*-
 * Copyright (C) @BABOLO  2002 Dec 23
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C) @BABOLO  2002 Dec 23\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: parser.c,v 1.1 2002/12/23 02:04:38 babolo Exp $";
#endif /* not lint */
#include <sys/types.h>
#include <sysexits.h>
#include <unistd.h>
#include <stdlib.h>
#include <limits.h>
#include <string.h>
#include <stdio.h>
#include <err.h>
#include <libpq-fe.h>
#include "pgm.h"
#include "pgoblin.h"

struct pgoblin *
parser(struct connopt *options, FILE *in, char *query) {
    struct pgoblin *pgm;
    enum command cmd;
    char *delim, *q;
    pnode ci;

    if  (v_flag > 3) fprintf( stderr, "+parser %s in=%s query=%s\n"
                            , options->query ? options->query : ""
                            , in ? "OK" : "NULL"
                            , query ? query : "NULL"
                            );
    if  (shurecon(options))                                                              return(NULL);
    if  (query) q = query;
    else if (in) {
        if  ((q = prefile(in, NULL, NULL)) == NULL)                                      return(NULL);
    } else if (options->query) q = options->query;
    else {                                if (v_flag >= 0) warnx("parser: No program"); return(NULL);}

    delim = "#";
    pgm = pgoblin_init();
    while (*q) {
        if (v_flag > 2) fprintf(stderr, "Next cmd~%s~\n", q);
        if  (0 != strncmp(delim, q, strlen(delim))) {
                                           if (v_flag >= 0) warnx("parser: No command"); return(NULL);
        }
        q += strlen(delim);
        cmd = cmd_seach(&q);
        if  (cmd == cmd_illegal)     {if (v_flag >= -1) errx(EX_DATAERR, "syntax"); exit(EX_DATAERR);}
        ci = pgoblin_new(pgm);
        pgm->code[ci].cmd = cmd;
        while (*q && *q != '\n') q++;
        if  (*q) *q++ = '\0';
        if (v_flag > 2) fprintf(stderr, "cmd=%d(%s) %08X\n", cmd, cmdstr[cmd], cmdkind[cmd]);
        if  (cmdkind[cmd] & TEXTPARM) {
            int i = 0;
            pgm->code[ci].parm = q;
            while (*q && 0 != strncmp(delim, q, strlen(delim))) {
                if (v_flag > 3) fprintf(stderr, "Next line~%s~\n", q);
                while (*q && *q != '\n') q++;
                q++;
                i = 1;
            }
            if  (i) *(q - 1) = '\0';
              else pgm->code[ci].parm = "";
        } else {
            pgm->code[ci].parm = NULL;
        }
    }
    return(pgm);
}
