/*-
 * Copyright (C) @BABOLO  2002 Dec 23
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C) @BABOLO  2002 Dec 23\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: pgm.c,v 1.1 2002/12/23 02:04:38 babolo Exp $";
#endif /* not lint */
#include <sys/types.h>
#include <sysexits.h>
#include <unistd.h>
#include <stdlib.h>
#include <limits.h>
#include <string.h>
#include <stdio.h>
#include <err.h>
#include <libpq-fe.h>
#include "pgm.h"
#include "pgoblin.h"

char *cmdstr[] = { ""
, "copyin "      , "copyout "
, "binselect "   , "strselect "
, "perform "     , "!"
, NULL
};

u_int32_t cmdkind[] = { 0
, TEXTPARM            , TEXTPARM
, TEXTPARM            , TEXTPARM
, TEXTPARM            , TEXTPARM
};

struct pgoblin *
pgoblin_init() {
    struct pgoblin *pgm;
    struct code_t *ppole;

    ppole = malloc(sizeof(struct code_t) * BUFSIZE);
    pgm = malloc(sizeof(struct pgoblin));
    pgm->maxx = 0;
    pgm->code = ppole;
    return(pgm);
}

pnode
pgoblin_new(struct pgoblin *pgm) {
    if  (pgm->maxx >= BUFSIZE)                                  errx(EX_SOFTWARE, "Programm too big");
    return(pgm->maxx++);
}

enum command
cmd_seach(char **q) {
    enum command cmd, i = cmd_null;
    size_t l = 0;

    if  (v_flag > 3) fprintf(stderr, "+cmd_seach %s~\n", *q);
    while (**q && **q == ' ') (*q)++;
    for (cmd = cmd_null; cmdstr[cmd]; cmd++) {
        if  (l < strlen(cmdstr[cmd]) && 0 == strncmp(*q, cmdstr[cmd], strlen(cmdstr[cmd]))) {
            l = strlen(cmdstr[cmd]);
            i = cmd;
    }   }
    if  (cmdstr[i]) *q += strlen(cmdstr[i]);
    if  (v_flag > 3) fprintf(stderr, "-cmd_seach %s~\n", *q);
    return(i);
}
